<?php
/*********************************************************************
*@filename assets_printer_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment

********************************************************************/
class AssetsNetscanController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Asthrd','Hrdnic','Macvendor','Netscan','Netscanignore','Grpauth','Hstloghead','Host','Rlthstgrp','Group',
		'Astose');
	var $layout='assets';


	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('prt title',$return = true);// 'LVシステム管理／全体設定／センサー';
		//================================yin c=======================
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
			//	    		debug($_POST['forHideVar']);
			//	    		echo "forHideVar===".$_POST['forHideVar']."++++++1++++<br>";
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
			//	    		debug($_POST['forHideVar1']);
			//	    		echo "forHideVar1===".$_POST['forHideVar1']."+++++2+++++<br>";
		}
		//		debug($_POST, true);
		//================================yin c=======================

	}

	function index($errorMessage = null)
	{
		//    	$glist = array(0 => __('whole',$return = true)); // 'すべて'
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		//		$glist[0] =  __('whole',$return = true);
		ksort($glist);
		$this->set('glist',$glist);
		
		$polllist = $this->Poll->generateList(null, null, null, '{n}.Poll.id', '{n}.Poll.poll_name', null);
		$polllist[0] =__('none_distribute', true);
		ksort($polllist);
		$this->set('plist',$polllist);
		
		if($errorMessage != null){
			echo "<div id='errmsg'>".
			__('index_error',$return = true).
			"</div>";
		}
	}
	function listdriver($csv = null)
	{
		$this->layout="ajax";
		
		$criteria[]="1=1";
		//入力データ取得
		$group = 1;//$this->data['Group']['group_name'];		
		if(isset($this->data['Poll']['id']))
			$poll = $this->data['Poll']['id'];
		
		if(isset($this->data['Netscan']['ostypes'])){
			$oses = "";
			$ostypes = $this->data['Netscan']['ostypes'];
			foreach($ostypes as $key => $os){
				$oses .= $os.",";
			}
			$oses = rtrim($oses, ","); 
			$criteria[]="Netscan.ostype in (".$oses.")";
		}
		
		if(isset($this->data['Netscan']['notregistered'])){
			if(1 == $this->data['Netscan']['notregistered']){
				$criteria[]="Host.access_name is null";
				$criteria[]="Hrdnic.ip_address is null";
			}
		}
		
		$count = $this->data['Netscan']['count'];
		if(!is_numeric($count))
			$count = 20;
		
		$keyword = $this->data['Netscan']['input_ip'];
		$keyword2 = $this->Lv->spec_char_dbm($keyword);

//debug($this->data);

		//取得条件設定
		$asso = array(
			/*'Rlthstgrp : rlthstgrps : LEFT' => array('Netscan.group_id = Rlthstgrp.group_id'),
			'Asthrd : asthrds' => array('Asthrd.host_id = Rlthstgrp.host_id'),
			'Hrdnic : hrdnics : LEFT' => array('Asthrd.id = Hrdnic.hardware_id'),*/
			/*'Hrdnic : hrdnics : LEFT' => array('Netscan.mac_address = Hrdnic.mac_address'),
			'Asthrd : asthrds : LEFT' => array('Asthrd.id = Hrdnic.hardware_id'),
			'Rlthstgrp : rlthstgrps : LEFT' => array('Asthrd.host_id = Rlthstgrp.host_id'),*/
			'Macvendor : mac2vendor : left' => array('Macvendor.mac = substring(Netscan.mac_address, 1, 8)'),
			'Host : hosts : left' => array('Host.access_name = Netscan.ip_address'),
			'Hrdnic : (select ip_address from hrdnics where ip_address != "" and hardware_id in(select asthrds.id from hosts inner join asthrds on hosts.id = asthrds.host_id)) : left' => array('Netscan.ip_address = Hrdnic.ip_address'),
			//'Hrdnic : hrdnics : left' => array('Netscan.ip_address = Hrdnic.ip_address'),
			'Netscanignore : netscanignore : left' => array('Netscan.ip_address = Netscanignore.ip_address'),
		) ;
		
		$fields = array(
		'Netscan.id',
		'Netscan.group_id',
		'Netscan.ip_address',
		'Netscan.ostype',
		'Netscan.mac_address',
		'Netscan.ip_subnet',
		'Netscan.broadcast',
		'Netscan.pc_name',
		'Netscan.model_name',
		'Netscan.print_count',
		'Netscan.init_date',
		'Netscan.final_date',
		'Macvendor.vendor',
		'Netscan.firm_version',
		//'Hrdnic.mac_address',
		//'Hrdnic.mac_address = Netscan.mac_address as Netscan__exists',
		'case when Host.access_name  is not null then 1 else 0 end as Netscan__tmp',
		'case when Hrdnic.ip_address is not null then 1 else 0 end as Netscan__exists',
		'case when (Netscanignore.ip_address is not null) then 2 when (Host.access_name  is not null or Hrdnic.ip_address is not null) then 1 else 0 end as Netscan__registered',
		);
		//Netscan__registered
		//0:PC登録用のリンク（アクセス名に無い、取得したNICのIPにない）
		//1:空欄表示（アクセス名にある、取得したNICのIPにある）
		//2:無視リストにある
		$group_ids = "";
		$glist = $this->Grpauth->getChildrenByParent($group);
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 

		
	//	$criteria[]="Netscan.group_id in (".$group_ids.")";
		
		$criteria[]="Netscan.ip_address like '".$keyword2."%'";
		$criteria["GROUP BY"]="Netscan.ip_address";

		//取得
		if($csv == 'csv'){
			$Hrdprts = $this->Netscan->findByAsso($criteria, $fields, 'Netscan.ip_address', null, null, $asso);
		}else{
			$this->Pagination->show = $count;
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/assets_netscan/listdriver', 'modelClass'=>'Netscan', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy('INET_ATON(Netscan.ip_address)')));
			$Hrdprts = $this->Netscan->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
		}
		
		//HW台帳に同じIPがないか探す
/*		$asso2 = array(
				'Rlthstgrp : rlthstgrps' => array('Asthrd.host_id = Rlthstgrp.host_id'),
				'Hrdnic : hrdnics' => array('Asthrd.id = Hrdnic.hardware_id'),
			) ;
		$fields2 = array(
			'Rlthstgrp.group_id',
			'Hrdnic.ip_address',
		);
	//	$crit[]="Rlthstgrp.group_id in (".$group_ids.")";
		$crit[]="Hrdnic.ip_address is not null";
		$crit[]="Hrdnic.ip_address != ''";
		$Asthrds = $this->Asthrd->findByAsso($crit, $fields2, null, null, null, $asso2);
		//debug($Asthrds);
		foreach($Hrdprts as $i => $scan)
		{
			//$Hrdprts[$i]['Netscan']['exists'] = "";
			foreach($Asthrds as $mac)
			{
				if($scan['Netscan']['ip_address'] == $mac['Hrdnic']['ip_address']){
					$Hrdprts[$i]['Netscan']['exists'] = 1;
					break;
				}
			}
		}
		*/	
		if($csv == 'csv'){
			$this->csvdown($Hrdprts,1);exit;
		}
//debug($Hrdprts);

		$criteria2[]="1=1";
	//	$criteria2[]="Netscan.group_id in (".$group_ids.")";

		$criteria2[]="Netscan.ip_address like '".$keyword2."%'";
		//$criteria2["GROUP BY"]="Hrdprt.hardware_id";
		$hardware_ids = $this->Netscan->findByAsso($criteria, array("Netscan.id"), null, null, null, $asso);
		

		//表示データ設定
		!empty($Hrdprts)?$this->set('data',$Hrdprts):$this->set('data',"");
		$this->set('device_count',count($hardware_ids));
		$this->set('countperpage',$count);	
		$this->set('group_id',$group);	
		$this->render('drivers');
	}

	function csvdown($data,$flag)
	{
		//$parent = $this->data['Selector']['parent_group'];
		$group = $this->data['Group']['group_name'];
		
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group));
		$group_n= $this->Group->findAll($criteria);
		$parent = $group_n[0]["Group"]["parent_id"];
		
		$this->data['Csv']['group'] = $this->groupName($group);
		/*if($parent == 1){
			$this->data['Csv']['group'] = $this->groupName($group);
			$this->data['Csv']['group2'] = "";
		}else{
			$this->data['Csv']['group'] = $this->groupName($parent);
			$this->data['Csv']['group2'] = $this->groupName($group);
		}*/
		
/*		
		if(isset($this->data['Selector']['input_keyword_check']))
			$this->data['Csv']['check'] = __('csv_on',$retrun=true);
		else
			$this->data['Csv']['check'] = __('csv_off',$retrun=true);
		*/
			
		require_once( 'csv/DlFactory.php' );
		
		$filename="";

		foreach($data as $i => $d){
			if(!empty($d['Netscan']['exists']))
				$data[$i]['Netscan']['exists'] = '○';
			
			if($d['Netscan']['ostype'] == 1)
				$data[$i]['Netscan']['ostype'] = __('ostype_win',true);
			else if($d['Netscan']['ostype'] == 2)
				$data[$i]['Netscan']['ostype']= __('ostype_mac',true);
			else if($d['Netscan']['ostype'] == 3){
				$data[$i]['Netscan']['ostype'] = __('ostype_linux',true);
			}
			else if($d['Netscan']['ostype'] == 4)
				$data[$i]['Netscan']['ostype'] = __('ostype_unix',true);
			else
				$data[$i]['Netscan']['ostype'] = __('ostype_unknown',true);
		}

		$csv = DlFactory::create("assets_netscan");
		if($flag == 1){
			$array = array(
				'Netscan/ip_address'=>__('ip_address', $return = true),
				'Netscan/exists'=>"",
				'Netscan/ostype'=>__('ostype', $return = true),
				'Netscan/mac_address'=>__('mac_address', $return = true),
				'Macvendor/vendor'=>__('nic_vendor', $return = true),
				'Netscan/ip_subnet'=>__('ip_subnet', $return = true),
				'Netscan/broadcast'=>__('broadcast', $return = true),
				'Netscan/pc_name'=>__('pc_name', $return = true),
				'Netscan/model_name'=>__('model_name', $return = true),
				'Netscan/firm_version'=>__('firm_version', $return = true),
				'Netscan/print_count'=>__('print_count', $return = true),
				'Netscan/init_date'=>__('init_date', $return = true),
				'Netscan/final_date'=>__('final_date', $return = true),
			);
			
			$filename=__('csv_file1',$return=true);
		}/*
		elseif($flag == 2){
			$array = array(
				'Netscan/ip_address'=>__('ip_address', $return = true),
				'Netscan/mac_address'=>__('mac_address', $return = true),
				'Macvendor/vendor'=>__('nic_vendor', $return = true),
				'Netscan/ip_subnet'=>__('ip_subnet', $return = true),
				'Netscan/broadcast'=>__('broadcast', $return = true),
				'Netscan/pc_name'=>__('pc_name', $return = true),
				'Netscan/model_name'=>__('model_name', $return = true),
				'Netscan/print_count'=>__('print_count', $return = true),
				'Netscan/init_date'=>__('init_date', $return = true),
				'Netscan/final_date'=>__('final_date', $return = true),
			);
			
			$filename=__('csv_file2',$return=true);
		}*/

		$csv->special_cols=$array;
		//debug($data);
		$csv->sendCSVFile($data,$this->data, $filename);

		exit;
	}
	function del(){
		$this->layout = 'ajax';
//var_dump($this->data['Netscan']['delid']);
		if(isset($this->data['Netscan']['delid'])){
			$ids  = $this->data['Netscan']['delid'];
			foreach ($ids as $i => $check){
				$this->Netscan->del($check);
			}
		}
		$this->listdriver();
	}
	
	function addhw(){
		$this->layout = 'ajax';
//var_dump($this->data['Netscan']['delid']);
		if(isset($this->data['Netscan']['delid'])){
			$ids  = $this->data['Netscan']['delid'];
			$hosts=$this->Host->findAll("Host.status not in (1,3)");
			$pc_num=$this->Host->query("select pc_num from licenses ");
			$exists = 0;
			foreach ($ids as $i => $check){
				$scan = $this->Netscan->find(array("Netscan.id" => $this->Lv->spec_char_dbm($check)));
				if(!empty($scan))
				{
					$nic = $this->Hrdnic->find(array("Hrdnic.mac_address" => $this->Lv->spec_char_dbm($scan['Netscan']['mac_address'])));
					if(!empty($nic))
					{
						//登録済み
						$exists++;
					}
				}
			}
			
			if(count($hosts) + count($ids) - $exists > $pc_num[0][0]['pc_num'])
			{
				//echo count($hosts) ."+". count($ids) ."-". $exists .">". $pc_num[0][0]['pc_num'];
				$this->set('pcnumover', 1);	
				$this->listdriver();
				return;
			}
		
			foreach ($ids as $i => $check){
				$scan = $this->Netscan->find(array("Netscan.id" => $this->Lv->spec_char_dbm($check)));
				if(!empty($scan))
				{
					$hostid = -1;
					//$scan['Netscan']['mac_address']
					$nic = $this->Hrdnic->find(array("Hrdnic.mac_address" => $this->Lv->spec_char_dbm($scan['Netscan']['mac_address'])));
					if(!empty($nic))
					{
						$hard = $this->Asthrd->find(array("Asthrd.id" => $nic['Hrdnic']['hardware_id']));
						if(!empty($hard))
						{
							$hostid = $hard['Asthrd']['host_id'];
							$this->Host->query("update hosts set host_name = '".$this->Lv->spec_char_dbm($scan['Netscan']['ip_address'])."', access_name = '".$this->Lv->spec_char_dbm($scan['Netscan']['ip_address'])."', update_time = '".date('Y-m-d H:i:s',time())."'".
							" where hosts.id = ".$hostid);
							
							
							$this->Asthrd->query("delete from asthrds where id = ".$hard['Asthrd']['id']."");
						}
					}
					
					if($hostid == -1){
						$this->Host->query("insert into hosts(host_name,access_name,username,password,poll_id,poll_type,update_time,regist_time,status,ostype) values('".
							$this->Lv->spec_char_dbm($scan['Netscan']['ip_address'])."','".
							$this->Lv->spec_char_dbm($scan['Netscan']['ip_address'])."','".
							""."','".
							""."',".
							"0".",".
							"0".",'".
							date('Y-m-d H:i:s',time())."','".
							date('Y-m-d H:i:s',time())."',".
							"0".",".
							"-1".")");
						$hostid = $this->Host->getLastInsertID();
						$this->Rlthstgrp->query("insert into rlthstgrps(host_id,group_id) values(".$hostid.", 1)");
					}
					//asthrds astoses
					$query = sprintf("insert into asthrds(host_id, machine, maker, serialno, UUID, log_time) values(%d,'%s','%s','%s','%s','%s')",
						$hostid,
						$this->Lv->spec_char_dbm($scan['Netscan']['model_name']),
						"","","",
						$scan['Netscan']['final_date']);
					$this->Asthrd->query($query);
					$hardwareid = $this->Asthrd->getLastInsertID();
					
					$query = sprintf("insert into astoses(hardware_id, os_name) values(%d,'%s')",
						$hardwareid,
						$this->Lv->spec_char_dbm($scan['Netscan']['firm_version']));
					$this->Astose->query($query);
					
					$query = sprintf("insert into hrdnics(hardware_id, mac_address, ip_address, ip_subnet, enableflg) values(%d,'%s','%s','%s', 1)",
						$hardwareid,
						$this->Lv->spec_char_dbm($scan['Netscan']['mac_address']),
						$this->Lv->spec_char_dbm($scan['Netscan']['ip_address']),
						$this->Lv->spec_char_dbm($scan['Netscan']['ip_subnet']));
					$this->Hrdnic->query($query);
				}
			}
		}
		$this->listdriver();
	}
	
	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
}
?>